#ifndef FLEX_LEXER_H
#define FLEX_LEXER_H

/*  This file should be accompanied by DISCLAIMER.TXT stating disclaimers */
 
#include "flexTokens.h"
#include "AToken.h"
#include "ATokenStream.h"

struct FlexLexer : public ANTLRTokenStream {

       /* constructor */        FlexLexer(FILE *);
       /* destructor  */ virtual    ~FlexLexer();
   
       virtual ANTLRAbstractToken * getToken();
       FILE *               file;
       int              foundEOF;
};

#endif
