#ifndef WSAST_H
#define WSAST_H

/*  This file should be accompanied by DISCLAIMER.TXT stating disclaimers */

#include "tokens.h"
#include "ASTBase.h"
#include "noleakAST.h"
#include "ATokPtr.h"

struct AST : public NoLeakAST {

       /* constructor */    AST(ANTLRTokenPtr t);
       /* destructor */ virtual ~AST();
       /* copy constructor */   AST(const AST &);      // new copy of token
       AST &            operator = (const AST &);  // new copy of token
       virtual void     dumpNode(const char * s=0);
       virtual void     preorder_action();

       ANTLRTokenPtr        pToken;
};

#endif
